#coding: utf-8
import os

import wx


class CameraArea():
    def __init__(self,frame):
        self.frame = frame
        self.mainPanel = None
        self.devId = "010000000000"
        self.channel = 1

    def setDevId(self,data):
        self.devId = data
    def setChannel(self,data):
        self.channel = data

    #################################################
    #       创建一个pannel
    #################################################
    def create(self):
        self.mainPanel = wx.Panel(self.frame)
        boxSizer = wx.BoxSizer(wx.VERTICAL)
        topPanel = wx.Panel(self.mainPanel)
        bottomPanel = wx.Panel(self.mainPanel)
        bottomPanel.SetBackgroundColour(wx.YELLOW)
        boxSizer.Add(topPanel,1,flag=wx.EXPAND | wx.ALL)
        boxSizer.Add(bottomPanel,2, flag=wx.EXPAND | wx.ALL)
        self.mainPanel.SetSizer(boxSizer)

        preView = wx.Panel(topPanel)
        boxSizer_preView = wx.BoxSizer(wx.VERTICAL)
        preView_staticText = wx.StaticText(preView, label='预览区域（未实现）：', pos=(10, 10))
        preView_content = wx.Panel(topPanel, style=wx.BORDER_SIMPLE)
        boxSizer_preView.Add(preView_staticText,1,flag=wx.EXPAND | wx.ALL)
        boxSizer_preView.Add(preView_content,11, flag=wx.EXPAND | wx.ALL)
        preView.SetSizer(boxSizer_preView)

        paramView = wx.Panel(topPanel)
        wx.StaticText(paramView, label='本地视频：', pos=(10, 10))
        videoPathText = wx.TextCtrl(paramView,pos=(70,5),size=wx.Size(300,-1))                                                  # 要推流的视频地址
        selectPathButton = wx.Button(paramView,label="选择视频文件",pos=(375,5))
        self.frame.Bind(wx.EVT_BUTTON, lambda evt,textCtr=videoPathText : self.selectVideoFile(evt,textCtr), selectPathButton)
        wx.StaticText(paramView, label='推流地址：', pos=(10, 40))
        pushHostText = wx.TextCtrl(paramView, pos=(70, 35), size=wx.Size(150, -1), value="10.100.11.125")                       # 推流地址
        wx.StaticText(paramView, label='推流端口：', pos=(235, 40))
        pushPortText = wx.TextCtrl(paramView, pos=(300, 35), size=wx.Size(80, -1), value="1078")                                # 推流端口
        wx.StaticText(paramView, label='设 备号：', pos=(10, 70))
        pushHostText = wx.TextCtrl(paramView, pos=(70, 65), size=wx.Size(150, -1), value=self.devId)                            # 设备号
        wx.StaticText(paramView, label='频 道号：', pos=(235, 70))
        pushPortText = wx.TextCtrl(paramView, pos=(300, 65), size=wx.Size(80, -1), value=str(self.channel))                     # 频道号
        wx.StaticText(paramView, label='当前状态：', pos=(10, 100))
        pushStatusText = wx.TextCtrl(paramView, pos=(70, 95), size=wx.Size(60, -1),value="未推流",style=wx.TE_READONLY)          # 推流状态显示
        pushStatusText.SetForegroundColour(wx.RED)
        wx.StaticText(paramView, label='消息发送间隔（毫秒）：', pos=(10, 130))
        msgSendDurText = wx.TextCtrl(paramView, pos=(150, 125), size=wx.Size(40, -1), value="7")                                # 消息发送间隔
        wx.StaticText(paramView, label='播放地址：', pos=(10, 190))
        msgSendDurText = wx.TextCtrl(paramView, pos=(70, 185), size=wx.Size(400, -1))                                           # 视频播放地址



        ctrView = wx.Panel(topPanel)
        startPushButton = wx.Button(ctrView, label="开始推流", pos=(5, 5))
        stopPushButton = wx.Button(ctrView, label="停止推流", pos=(90, 5))
        ctrView.SetBackgroundColour(wx.RED)

        boxSizer_1 = wx.BoxSizer(wx.HORIZONTAL)
        boxSizer_1.Add(preView,1,flag=wx.EXPAND | wx.ALL)
        boxSizer_1.Add(paramView, 2, flag=wx.EXPAND | wx.ALL)
        boxSizer_1.Add(ctrView, 1, flag=wx.EXPAND | wx.ALL)
        topPanel.SetSizer(boxSizer_1)

        return self.mainPanel


    def selectVideoFile(self,evt,textCtr):
        wildcard = "Video file (*.flv)|*.flv"
        dlg = wx.FileDialog(
            self.frame, message="Choose a file",
            defaultDir=os.getcwd(),
            defaultFile="",
            wildcard=wildcard,
            style=wx.FD_OPEN |
                  wx.FD_CHANGE_DIR | wx.FD_FILE_MUST_EXIST |
                  wx.FD_PREVIEW
        )
        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            textCtr.SetValue(path)
        dlg.Destroy()